_kanidm_ssh_authorizedkeys() {
    local i cur prev opts cmd
    COMPREPLY=()
    cur="${COMP_WORDS[COMP_CWORD]}"
    prev="${COMP_WORDS[COMP_CWORD-1]}"
    cmd=""
    opts=""

    for i in ${COMP_WORDS[@]}
    do
        case "${cmd},${i}" in
            ",$1")
                cmd="kanidm_ssh_authorizedkeys"
                ;;
            *)
                ;;
        esac
    done

    case "${cmd}" in
        kanidm_ssh_authorizedkeys)
            opts="-d -v -h --debug --version --help [ACCOUNT_ID]"
            if [[ ${cur} == -* || ${COMP_CWORD} -eq 1 ]] ; then
                COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
                return 0
            fi
            case "${prev}" in
                *)
                    COMPREPLY=()
                    ;;
            esac
            COMPREPLY=( $(compgen -W "${opts}" -- "${cur}") )
            return 0
            ;;
    esac
}

if [[ "${BASH_VERSINFO[0]}" -eq 4 && "${BASH_VERSINFO[1]}" -ge 4 || "${BASH_VERSINFO[0]}" -gt 4 ]]; then
    complete -F _kanidm_ssh_authorizedkeys -o nosort -o bashdefault -o default kanidm_ssh_authorizedkeys
else
    complete -F _kanidm_ssh_authorizedkeys -o bashdefault -o default kanidm_ssh_authorizedkeys
fi
